//+------------------------------------------------------------------+
//|                                                  ATR Levels2.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 0

//
//
//
//
//

extern string UniqueID           = "AtrLevels";
extern int    ATRPeriod          = 10;
extern int    DayToShow          = 0;
extern color  ColorUpYesterday   = IndianRed;
extern color  ColorUpToday       = Magenta;
extern color  ColorDownYesterday = IndianRed;
extern color  ColorDownToday     = Magenta;
extern int    StyleUpToday       = STYLE_SOLID;
extern int    StyleUpYesterday   = STYLE_DOT;
extern int    StyleDownToday     = STYLE_SOLID;
extern int    StyleDownYesterday = STYLE_DOT;
extern int    ShiftRightBars     = 25;
extern int    ShiftRightTextBars = 40;
extern int    TextFontSize       = 9;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init() {  return(0); }
int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);   
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
         if (StringSubstr(name,0,lookForLength) == lookFor) ObjectDelete(name);
   }         
   return(0);
}

//
//
//
//
//

int start()
{
   if(Period() > PERIOD_H4) return(-1);

   int day1shift = 0;            if (TimeDayOfWeek(iTime(NULL,PERIOD_D1,DayToShow+day1shift))==0) day1shift++;
   int day2shift = day1shift+1;  if (TimeDayOfWeek(iTime(NULL,PERIOD_D1,DayToShow+day2shift))==0) day2shift++;
   
      double fullatr       = iATR(NULL,PERIOD_D1,ATRPeriod,DayToShow+day2shift);
      double LowYesterday  = iHigh(NULL,PERIOD_D1,DayToShow+day2shift)- fullatr;
      double HighYesterday = iLow(NULL,PERIOD_D1,DayToShow+day2shift) + fullatr;
      double LowToday      = iHigh(NULL,PERIOD_D1,DayToShow+day1shift)- fullatr;
      double HighToday     = iLow(NULL,PERIOD_D1,DayToShow+day1shift) + fullatr;
   
         createLine("0",LowYesterday ,ColorDownYesterday, StyleDownYesterday);
         createLine("1",LowToday     ,ColorDownToday,     StyleDownToday);
         createLine("2",HighYesterday,ColorUpYesterday,   StyleUpYesterday);
         createLine("3",HighToday    ,ColorUpToday,       StyleUpToday );
         createPrice("4" ,LowYesterday  ,ColorDownYesterday);
         createPrice("5" ,LowToday      ,ColorDownToday);
         createPrice("6" ,HighYesterday ,ColorUpYesterday);
         createPrice("7" ,HighToday     ,ColorUpToday);
         createLabel("8" ,LowYesterday  ,ColorDownYesterday,"yesterday low");
         createLabel("9" ,HighYesterday ,ColorUpYesterday  ,"yesterday high");
         createLabel("10",LowToday      ,ColorDownToday    ,"today low");
         createLabel("11",HighToday     ,ColorUpToday      ,"today high");

   return(0);
}

//
//
//
//
//

void createLine(string name, double price, color theColor, int style=STYLE_SOLID, int width=1)
{
   name = UniqueID+":"+name;
   ObjectCreate(name,OBJ_TREND,0,Time[0]+Period()*ShiftRightBars*60,price,Time[0]+(ShiftRightBars+1)*60,price);
         ObjectSet(name,OBJPROP_TIME1,Time[0]+Period()*ShiftRightBars*60);
         ObjectSet(name,OBJPROP_TIME2,Time[0]+Period()*(ShiftRightBars+1)*60);
         ObjectSet(name,OBJPROP_PRICE1,price);
         ObjectSet(name,OBJPROP_PRICE2,price);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,style);
         ObjectSet(name,OBJPROP_WIDTH,width);
}
void createPrice(string name, double price, color theColor)
{
   name = UniqueID+":"+name;
   ObjectCreate(name,OBJ_ARROW,0,Time[0]+Period()*ShiftRightBars*60,price);
         ObjectSet(name,OBJPROP_TIME1,Time[0]+Period()*ShiftRightBars*60);
         ObjectSet(name,OBJPROP_PRICE1,price);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_ARROWCODE,5);
}
void createLabel(string name, double price, color theColor, string text)
{
   name = UniqueID+":"+name;
   ObjectCreate(name,OBJ_TEXT,0,Time[0]+Period()*ShiftRightTextBars*60,price);
         ObjectSet(name,OBJPROP_TIME1,Time[0]+Period()*ShiftRightTextBars*60);
         ObjectSet(name,OBJPROP_PRICE1,price);
         ObjectSetText(name,text,TextFontSize,"Arial",theColor);
}

